#!/bin/bash

function permissions
{
	chmod +x micko;
	chmod +x node;
}

function server
{
	if pgrep "node" > /dev/null; then
		echo "Server already running at localhost:8080!"
	else
		./node server.js;
		echo "Server running at localhost:8080"
	fi
}

function open
{
	if which xdg-open > /dev/null
		then xdg-open http://localhost:8080
  	elif which gnome-open > /dev/null
		then gnome-open http://localhost:8080
	fi
}

function main
{
	exec & permissions;
	exec & server & disown;
	sleep 2;
	exec & open;
}

main;


